<%@ Application %>
<%@ Import Namespace="System.Web.Security" %>
<%@ Import Namespace="System.Security.Principal" %>
<script runat="server" language="C#">
void FormsAuthentication_OnAuthenticate(object sender, FormsAuthenticationEventArgs e) {
}

void Application_AuthenticateRequest(object sender, EventArgs e) {
	HttpCookie cookie = Context.Request.Cookies[
		FormsAuthentication.FormsCookieName];

	if (cookie == null) return;

	FormsAuthenticationTicket ticket = null;
	try {
		ticket = FormsAuthentication.Decrypt(cookie.Value);
	}
	catch (Exception ex) {
	}

	if (ticket == null) return;

	string role = ticket.UserData;

	FormsIdentity identity = new FormsIdentity(ticket);
	GenericPrincipal principal = new GenericPrincipal(
		identity, new string[] { role });
	Context.User = principal;
}
</script>
